// a mirror

#local Eighth=intersection {
  union {
    lathe { 7,<0,0>,<0,1.5>,<.5,2>,<4.5,2>,<5,1.5>,<5,0>,<0,0> transform FlipYZ }  
    torus { 4.5,.5 translate y*1.5 transform FlipYZ }
    torus { 0.5,.5 translate y*1.5 transform FlipYZ }
  }
  plane {-y,0}
  plane {y-x,0}
  bounded_by { box { <0,0,0>,<5,5,2> } }
}  

#local Oak=texture {
  pigment { wood ramp_wave frequency 2 turbulence .2 scale <1,1,10>
    color_map {
      [.50 rgb <1,.8,.6>]
      [.97 rgb <.8,.7,.5>]
      [1 rgb <1,.8,.6>]
    }
  }
}

union {
  polygon { 5,
    <-25, 30,1>,< 25, 30,1>,< 25,105,1>,<-25,105,1>,<-25, 30,1>
    pigment { rgb 1 }
    finish { reflection .98 diffuse .01 ambient .01 }
  }  
  polygon { 5,
    <-25, 30,1.25>,< 25, 30,1.25>,< 25,105,1.25>,<-25,105,1.25>,<-25, 30,1.25>
    pigment { rgbt 1 }
    finish { reflection .02 diffuse 0 ambient 0 }
  }  

  union { // bottom frame piece
    prism { -25,25,7,
      <25,0>,<30,0>,<30,1.5>,<29.5,2>,<25.5,2>,<25,1.5>,<25,0>
      matrix <0,1,0, 1,0,0, 0,0,1, 0,0,0>
    }
    cylinder { <-25, 25.5,1.5>,<25, 25.5,1.5>,.5 }
    cylinder { <-25, 29.5,1.5>,<25, 29.5,1.5>,.5 }
    object { Eighth matrix < 0,-1,0, 1,0,0, 0,0,1,  25,30,0> }
    object { Eighth matrix < 0,-1,0,-1,0,0, 0,0,1, -25,30,0> }
      
    texture { Oak transform FlipXZ }  
  } // end of bottom frame piece

  union { // top frame piece
    prism { -25,25,7,
      <105,0>,<110,0>,<110,1.5>,<109.5,2>,<105.5,2>,<105,1.5>,<105,0>
      matrix <0,1,0, 1,0,0, 0,0,1, 0,0,0>
    }
    cylinder { <-25,105.5,1.5>,<25,105.5,1.5>,.5 }
    cylinder { <-25,109.5,1.5>,<25,109.5,1.5>,.5 }
    object { Eighth matrix < 0, 1,0, 1,0,0, 0,0,1,  25,105,0> }
    object { Eighth matrix < 0, 1,0,-1,0,0, 0,0,1, -25,105,0> }

    texture { Oak transform FlipXZ }  
  } // end of top frame piece

  union { // left frame piece
    prism { 30,105,7,
      <-30,0>,<-30,1.5>,<-29.5,2>,<-25.5,2>,<-25,1.5>,<-25,0>,<-30,0> }  
    cylinder { <-25.5,30,1.5>,<-25.5,105,1.5>,.5 }
    cylinder { <-29.5,30,1.5>,<-29.5,105,1.5>,.5 }
    object { Eighth matrix <-1,0,0, 0, 1,0, 0,0,1, -25,105,0> }
    object { Eighth matrix <-1,0,0, 0,-1,0, 0,0,1, -25, 30,0> }

    texture { Oak transform FlipYZ }  
  } // end of left frame piece

  union { // right frame piece
    prism { 30,105,7, <30,0>,<30,1.5>,<29.5,2>,<25.5,2>,<25,1.5>,<25,0>,<30,0> }
    cylinder { < 25.5,30,1.5>,< 25.5,105,1.5>,.5 }
    cylinder { < 29.5,30,1.5>,< 29.5,105,1.5>,.5 }
    object { Eighth matrix <1,0,0, 0, 1,0, 0,0,1, 25,105,0> }
    object { Eighth matrix <1,0,0, 0,-1,0, 0,0,1, 25, 30,0> }
      
    texture { Oak transform FlipYZ }  
  } // end of right frame piece

  Matrix(MirrorX,MirrorY,MirrorZ,MirrorL)
}
    